Index: trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Bdd/src/BaseP_accessors.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Bdd/src/BaseP_accessors.cpp	(revision 21)
+++ trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Bdd/src/BaseP_accessors.cpp	(revision 26)
@@ -13,4 +13,8 @@
     comment=s;
   }
+  void BaseP::setLevel(int s){
+    level=s;
+  }
+ 
   void BaseP::setArchitecture(Architecture *a)
   {
@@ -35,4 +39,8 @@
     return comment;
   }
+  int BaseP::getLevel()
+  {
+    return level;
+  }
 
     QList<morpheo::tools::viewer::bdd::Component> *BaseP::getComponent()
Index: trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Bdd/src/BaseV_accessors.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Bdd/src/BaseV_accessors.cpp	(revision 21)
+++ trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Bdd/src/BaseV_accessors.cpp	(revision 26)
@@ -10,5 +10,5 @@
 namespace bdd{     
 
- void BaseV::setComment(string s){
+  void BaseV::setComment(string s){
     comment=s;
   }
Index: trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Bdd/src/BaseV_afficheBaseConsole.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Bdd/src/BaseV_afficheBaseConsole.cpp	(revision 21)
+++ trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Bdd/src/BaseV_afficheBaseConsole.cpp	(revision 26)
@@ -1,3 +1,3 @@
- /*
+/*
  *
  * [desc.]
@@ -13,4 +13,5 @@
         = pos->begin(); it != pos->end(); ++it)
     {
+     
       morpheo::tools::viewer::bdd::Entity *test=(it->getEntity());
       string n2=test->getName();
@@ -18,5 +19,5 @@
       cout << n << endl ;
       cout << "----Entity-----------------------------------------" <<endl;
-      cout << "Entity name:"<< n2<< endl;
+      cout << "Entity name:"<< n2 <<" level:"<< it->getLevel()<< endl;
       cout << "------------------ports east-----------------------" <<endl;
       
@@ -100,12 +101,14 @@
 	   cout << "port :" << it3->getPort() <<endl;
 	   cout << "comment :" << it3->getComment() <<endl;
-	  
-	  
+
+	   
 	   
 	     }
 	 }
       }//if
+      cout << endl<< "************    fin BASEP  *******************"<<endl <<endl;
+	
     }//for
-    
+      
   }
   
Index: trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Bdd/src/BaseV_getSignal.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Bdd/src/BaseV_getSignal.cpp	(revision 21)
+++ trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Bdd/src/BaseV_getSignal.cpp	(revision 26)
@@ -9,9 +9,14 @@
 namespace viewer{
 namespace bdd{  
-
-  morpheo::tools::viewer::bdd::Signal *BaseV::getSignal(string c,morpheo::tools::viewer::bdd::PortMap *dest)
+  /*
+   * search and find the signal 
+   * top : actual component is viewed on screen
+   * c: the component (source) which is connected to the dest
+   * dest : the port destination informations
+   */
+  morpheo::tools::viewer::bdd::Signal *BaseV::getSignal(BaseP *top,string c,morpheo::tools::viewer::bdd::PortMap *dest)
   {
     int srcX,srcY,destX,destY;
-    Architecture *aa=((pos->operator[](0)).getArchitecture());
+    Architecture *aa=top->getArchitecture();
     morpheo::tools::viewer::bdd::Component x=aa->getComponent(c);
     // cout << dest->getName() <<endl;  
@@ -19,5 +24,5 @@
     srcX=p->get_x();
     srcY=p->get_y();
-    // cout << dest->getComponent() <<endl;  
+    //cout << dest->getComponent() <<endl;  
     morpheo::tools::viewer::bdd::BaseP res=get_BasePos(dest->getComponent());
     morpheo::tools::viewer::bdd::Port *pm=(res.getEntity())->searchPort(dest->getPort());
Index: trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Bdd/src/BaseV_searchComponent.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Bdd/src/BaseV_searchComponent.cpp	(revision 21)
+++ trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Bdd/src/BaseV_searchComponent.cpp	(revision 26)
@@ -1,2 +1,3 @@
+
  /*
  *
@@ -11,5 +12,9 @@
 
   morpheo::tools::viewer::bdd::BaseP BaseV::get_BasePos(string v){ 
-    return pos->operator[](listcomp->indexOf(v,0));
+    int tmp=listcomp->indexOf(v,0);
+    if(tmp==-1)
+      return NULL;
+    else
+      return pos->operator[](tmp);
   }
 
Index: trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Bdd/src/Component_accessors.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Bdd/src/Component_accessors.cpp	(revision 21)
+++ trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Bdd/src/Component_accessors.cpp	(revision 26)
@@ -16,5 +16,5 @@
   string Component::getComment(){ return comment;}
   string Component::getName(){ return name;}
-    string Component::getType(){ return type;}
+  string Component::getType(){ return type;}
   int Component::get_x(){return pos_x+size_x;}
   int Component::get_y(){return pos_y+size_y;}
Index: trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Bdd/src/Entity_accessors.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Bdd/src/Entity_accessors.cpp	(revision 21)
+++ trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Bdd/src/Entity_accessors.cpp	(revision 26)
@@ -18,4 +18,5 @@
   
   string Entity::getName(){ return name;}
+  string Entity::getType(){ return type;}
   
   int Entity::getSchema(){return schema;}
Index: trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Bdd/src/Entity_alloc.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Bdd/src/Entity_alloc.cpp	(revision 21)
+++ trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Bdd/src/Entity_alloc.cpp	(revision 26)
@@ -11,10 +11,10 @@
 
 
-  Entity::Entity(string n,int l)
+  Entity::Entity(string n,string t,int l)
     :ListePorts()
   {
     name=n;
     schema=l;
-
+    type=t;
   }
  
